#include <stdlib.h>
#include <stdio.h>
#include <assert.h>
#include <time.h>

typedef struct plug_t {
    char* name; // Always keep these on top
    char* version;
} plug_t;


static plug_t* p = {0};


void* plug_init(void) {
    p = malloc(sizeof(plug_t));
    assert(p);
    p->name = "time-since";
    p->version = "0.0.1";
    return p;
}

void* plug_pre_reload(void) {
    return p; // send state to dim
}

void plug_post_reload(void* pp) {
    p = pp; // get back state
}

void plug_poll(char* buf, size_t len) {
    struct tm t = {0};
    t.tm_year = 2024 - 1900;
    t.tm_mon = 2;
    t.tm_mday = 8;

    time_t diff = difftime(time(0), mktime(&t)) / (60 * 60 * 24);

    snprintf(buf, len, " %ld days <3", diff);
}

void plug_free(void) {
    free(p); // free state
}
